---
title: Stacking with floated blocks
slug: Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_and_float
tags:
  - Advanced
  - CSS
  - Guide
  - Reference
  - Understanding_CSS_z-index
  - z-index
---
<div>{{cssref}}</div>

<p>For floated blocks, the stacking order is a bit different. Floating blocks are placed between non-positioned blocks and positioned blocks:</p>

<ol>
 <li>The background and borders of the root element</li>
 <li>Descendant <a href="/en-US/docs/Web/CSS/position#static">non-positioned</a> blocks, in order of appearance in the HTML</li>
 <li><em>Floating blocks</em></li>
 <li>Descendant <a href="/en-US/docs/Web/CSS/position#Types_of_positioning">positioned</a> elements, in order of appearance in the HTML</li>
</ol>

<p>Actually, as you can see in the example below, the background and border of the non-positioned block (DIV #4) is completely unaffected by floating blocks, but the content is affected. This happens according to standard float behaviour. This behavior can be shown with an added rule to the above list:</p>

<ol>
 <li>The background and borders of the root element</li>
 <li>Descendant <a href="/en-US/docs/Web/CSS/position#static">non-positioned</a> blocks, in order of appearance in the HTML</li>
 <li>Floating blocks</li>
 <li><em>Descendant <a href="/en-US/docs/Web/CSS/position#static">non-positioned</a> inline elements</em></li>
 <li>Descendant <a href="/en-US/docs/Web/CSS/position#Types_of_positioning">positioned</a> elements, in order of appearance in the HTML</li>
</ol>

<p>{{EmbedLiveSample("Source_code_for_the_example", 600, 250)}}</p>

<div class="note">
<p><strong>Note:</strong> If an <code>opacity</code> value is applied to the non-positioned block (DIV #4), then something strange happens: the background and border of that block pops up above the floating blocks and the positioned blocks. This is due to a peculiar part of the specification: applying a <code>opacity</code> value creates a new stacking context (see <a href="https://philipwalton.com/articles/what-no-one-told-you-about-z-index/">What No One Told You About Z-Index</a>).</p>
</div>

<h2 id="Source_code_for_the_example">Source code for the example</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;div id="abs1"&gt;
  &lt;b&gt;DIV #1&lt;/b&gt;&lt;br /&gt;position: absolute;&lt;/div&gt;

&lt;div id="flo1"&gt;
  &lt;b&gt;DIV #2&lt;/b&gt;&lt;br /&gt;float: left;&lt;/div&gt;

&lt;div id="flo2"&gt;
  &lt;b&gt;DIV #3&lt;/b&gt;&lt;br /&gt;float: right;&lt;/div&gt;

&lt;br /&gt;

&lt;div id="sta1"&gt;
  &lt;b&gt;DIV #4&lt;/b&gt;&lt;br /&gt;no positioning&lt;/div&gt;

&lt;div id="abs2"&gt;
  &lt;b&gt;DIV #5&lt;/b&gt;&lt;br /&gt;position: absolute;&lt;/div&gt;

&lt;div id="rel1"&gt;
  &lt;b&gt;DIV #6&lt;/b&gt;&lt;br /&gt;position: relative;&lt;/div&gt;

</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">div {
  padding: 10px;
  text-align: center;
}

b {
  font-family: sans-serif;
}

#abs1 {
  position: absolute;
  width: 150px;
  height: 200px;
  top: 10px;
  right: 140px;
  border: 1px dashed #900;
  background-color: #fdd;
}

#sta1 {
  height: 100px;
  border: 1px dashed #996;
  background-color: #ffc;
  margin: 0px 10px 0px 10px;
  text-align: left;
}

#flo1 {
  margin: 0px 10px 0px 20px;
  float: left;
  width: 150px;
  height: 200px;
  border: 1px dashed #090;
  background-color: #cfc;
}

#flo2 {
  margin: 0px 20px 0px 10px;
  float: right;
  width: 150px;
  height: 200px;
  border: 1px dashed #090;
  background-color: #cfc;
}

#abs2 {
  position: absolute;
  width: 150px;
  height: 100px;
  top: 80px;
  left: 100px;
  border: 1px dashed #990;
  background-color: #fdd;
}

#rel1 {
  position: relative;
  border: 1px dashed #996;
  background-color: #cff;
  margin: 0px 10px 0px 10px;
  text-align: left;
}
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_without_z-index">Stacking without the z-index property</a>: The stacking rules that apply when <code>z-index</code> is not used.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Adding_z-index">Using z-index</a>: How to use <code>z-index</code> to change default stacking.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/The_stacking_context">The stacking context</a>: Notes on the stacking context.</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_1">Stacking context example 1</a>: 2-level HTML hierarchy, z-index on the last level</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_2">Stacking context example 2</a>: 2-level HTML hierarchy, z-index on all levels</li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Positioning/Understanding_z_index/Stacking_context_example_3">Stacking context example 3</a>: 3-level HTML hierarchy, z-index on the second level</li>
</ul>

<div class="originaldocinfo">
<h2 id="Original_Document_Information">Original Document Information</h2>

<ul>
 <li>Author(s): Paolo Lombardi</li>
 <li>This article is the English translation of an article I wrote in Italian for <a class="external" href="http://www.yappy.it">YappY</a>. I grant the right to share all the content under the <a class="external" href="http://creativecommons.org/licenses/by-sa/2.0/">Creative Commons: Attribution-Sharealike license</a>.</li>
 <li>Last Updated Date: November 3, 2014</li>
</ul>
</div>
